diff -r 7353e3253840 src/imap/imap-client.c
--- a/src/imap/imap-client.c	Wed Dec 08 23:17:11 2010 +0000
+++ b/src/imap/imap-client.c	Thu Dec 09 04:25:29 2010 +0000
@@ -524,6 +524,7 @@
 		cmd->cancel = FALSE;
 		client_send_tagline(cmd, "NO Command cancelled.");
 	}
+	logcs(t_strdup_printf("finished: %s %s", cmd->name, cmd->args));
 
 	if (!cmd->param_error)
 		client->bad_counter = 0;
@@ -664,6 +665,7 @@
 			client_add_missing_io(client);
 			return TRUE;
 		}
+		logcs(t_strdup_printf("unfinished input: %s %s", cmd->name, cmd->args));
 
 		return client_handle_unfinished_cmd(cmd);
 	}
@@ -828,9 +830,10 @@
 	/* continue processing command */
 	finished = cmd->func(cmd) || cmd->state == CLIENT_COMMAND_STATE_DONE;
 
-	if (!finished)
+	if (!finished) {
+		logcs(t_strdup_printf("unfinished output: %s %s", cmd->name, cmd->args));
 		(void)client_handle_unfinished_cmd(cmd);
-	else {
+	} else {
 		/* command execution was finished */
 		client_command_free(&cmd);
 	}
diff -r 7353e3253840 src/imap/main.c
--- a/src/imap/main.c	Wed Dec 08 23:17:11 2010 +0000
+++ b/src/imap/main.c	Thu Dec 09 04:25:29 2010 +0000
@@ -23,6 +23,8 @@
 #include <stdlib.h>
 #include <unistd.h>
 
+#include <sys/time.h>
+#include <sys/resource.h>
 #define IS_STANDALONE() \
         (getenv(MASTER_IS_PARENT_ENV) == NULL)
 
@@ -43,6 +45,18 @@
 	return old_hook;
 }
 
+void logcs(const char *name)
+{
+	static struct rusage prev_ru;
+	struct rusage ru;
+
+	if (getrusage(RUSAGE_SELF, &ru) == 0) {
+		i_debug("%s: volcs=%lu (+%u)", name, ru.ru_nvcsw,
+			(unsigned int)(ru.ru_nvcsw - prev_ru.ru_nvcsw));
+		prev_ru = ru;
+	}
+}
+
 void imap_refresh_proctitle(void)
 {
 #define IMAP_PROCTITLE_PREFERRED_LEN 80
@@ -208,6 +222,7 @@
 	if (set->verbose_proctitle)
 		verbose_proctitle = TRUE;
 
+	logcs("client created");
 	client = client_create(fd_in, fd_out, mail_user, user, set);
 	T_BEGIN {
 		client_add_input(client, input_buf);
